﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Data;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Problems.DataAnalysis.Interfaces;

namespace HeuristicLab.Problems.DataAnalysis {
  [StorableClass]
  public class IntervalItem : NamedItem, IInterval {
    public IntervalItem() : base() {
      Name = "Constraint";
      Variable.SetValue("");
      Formulation.SetValue("");
    }

    public IntervalItem(string name, string variable, string formulation) {
      Name = name;
      Variable.SetValue(variable);
      Formulation.SetValue(formulation);
    }

    [StorableConstructor]
    protected IntervalItem(bool deserializing) : base(deserializing) { }
    protected IntervalItem(IntervalItem original, Cloner cloner)
      : base(original, cloner) {
      variable = original.variable;
      formulation = original.formulation;
      name = original.name;
    }

    protected IStringConvertibleValue variable = new StringValue();

    public IStringConvertibleValue Variable {
      get { return variable; }
    }

    protected IStringConvertibleValue formulation = new StringValue();
    public IStringConvertibleValue Formulation {
      get { return formulation; }
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new IntervalItem(this, cloner);
    }


  }
}
